#ifndef	__MSGHDR_HPP

#define	__MSGHDR_HPP

#include	"mb_lib.h"

class MsgHdr
{
	private:

	protected:

		MSGHDR_RECORD	hdr;

	public:

		//	Hudson message attributes

		enum {	Deleted = 0x0001, Unsent = 0x0002, Netmail = 0x0004,
				Private = 0x0008, Received = 0x0010, Unmoved = 0x0020,
				Local = 0x0040,

		//	Hudson netmail attributes

				Kill = 0x0100, Sent = 0x0200, File = 0x0400,
				Crash = 0x0800, Receipt = 0x1000, Audit = 0x2000,
				Return = 0x4000 };

		//	Constructors and destructor definitions

				MsgHdr (void) {	msg_hdr_clear (&hdr); };
		virtual	~MsgHdr (void) {};

		//	Methods

		void	HdrClear (void) { msg_hdr_clear (&hdr); };

		char *	To (void) { return (hdr.who_to); };
		void	To (char *_user);
		void	To (char *_user, int zone, int net, int node);

		char *	From (void) { return (hdr.who_from); };
		void	From (char *_user);
		void	From (char *_user, int zone, int net, int node);

		char *	Subject (void) { return (hdr.subject); };
		void	Subject (char *_subject);

		unsigned	MsgNum (void) { return (hdr.msgnum); };
		void		MsgNum (unsigned _msgnum) { hdr.msgnum = _msgnum; };

		unsigned	Board (void) { return (hdr.board); };
		void		Board (int _board) { hdr.board = _board; };

		unsigned	Cost (void) { return (hdr.cost); };
		void		Cost (unsigned _cost) { hdr.cost = _cost; };

		void	SetAttribute (unsigned _attributes);
		void	UnsetAttribute (unsigned _attributes);
};

#endif
