#ifndef __NETHDR_HPP

#define __NETHDR_HPP

#include "mb_lib.h"

class NetHdr
{
	private:

	protected:

		NET_RECORD  hdr;

	public:

		//	Opus (*.msg) message attributes

		enum {	Private = 0x0001,	Crash = 0x0002,		Received = 0x0004,
				Sent = 0x0008, 		File = 0x0010, 		Transit = 0x0020,
				Orphan = 0x0040, 	Kill = 0x0080, 		Local = 0x0100,
				Hold = 0x0200, 		Unused = 0x0400, 	Request = 0x0800,
				Receipt = 0x1000, 	IsReceipt = 0x2000, Audit = 0x4000,
				UpdateReq = 0x8000 };

		//	Constructors and desctrutor definition

				NetHdr (void) { net_hdr_clear (&hdr); };
		virtual	~NetHdr (void) {};

		//	Methods

		void From (char *name, int zone, int net, int node, int point);
		void To (char *name, int zone, int net, int node, int point);
		void From (char *name, int net, int node);
		void To (char *name, int net, int node);
		void Subject (char *subject);
		void SetAttribute (unsigned int attr);
		void UnsetAttribute (unsigned int attr);
};

#endif
